=== debian/control ===
Source: ros-noetic-robotraconteur
Section: misc
Priority: optional
Maintainer: John Wason <wason@wasontech.com>
Build-Depends: debhelper (>= 9.0.0), libbluetooth-dev, libboost-all-dev, libdbus-1-dev, libssl-dev, libusb-1.0-0-dev, openssl, python3-dev, python3-numpy, ros-noetic-catkin, zlib1g-dev
Homepage: http://robotraconteur.com
Standards-Version: 3.9.2

Package: ros-noetic-robotraconteur
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libbluetooth-dev, libboost-all-dev, libdbus-1-dev, libssl-dev, libusb-1.0-0-dev, openssl, python3-dev, python3-numpy, zlib1g-dev
Description: Robot Raconteur ROS Package
